#include <stdio.h>
void ra144(FILE *fdo,FILE *fd);
void ra288(FILE *fdo,FILE *fd, long pos);

int main(int ac, char **av)
{
   static unsigned char in[256];
   FILE *fd,*fdo=NULL;

   if ((ac == 3)||(ac==2)) {
      fd=fopen(av[1],"rb");
      if(fd==0) {
         fprintf(stderr,"file not found %s",av[1]);
         exit(1);
         }
      if (ac==3) {
         fdo=fopen(av[2],"wb");
         if (!fdo) {
            fprintf(stderr,"Can't open output file %s",av[2]);
            exit(1);
            }
         }
      }
   else {
      fprintf(stderr,"Usage: RAPlay infile [outfile]");
      exit(1);
      }

   fread(in,6,1,fd);
   if(!strncmp(in,".ra",3) &&in[3]==0xfd && in[4]==0) {
		if (in[5]==3)
  	{
	 		fprintf(stderr,"recognized format: 14.4kbaud file\n");
			ra144(fdo,fd);
  	}
		else if (in[5]==4)
  	{
			long pos;
			unsigned char sig2[12];
			fread(sig2,12,1,fd);
			fread(in,4,1,fd);
  		pos=(in[0]<<24|in[1]<<16|in[2]<<8|in[3])+0x10;
			fread(in,0x16,1,fd);
			if (!strncmp(sig2+2,".ra4",4) && in[4] == 0 || in[5] == 0x26
					&& in[0x12] == 0 && in[0x13] == 12 && in[0x14] == 0 && in[0x15] == 0xe4) {
	 			fprintf(stderr,"recognized format: 28.8kbaud file\n");
				ra288(fdo,fd,pos);
			}
			else {
	 			fprintf(stderr,"recognized format: 28.8kbaud, unrecognized file parameters");
				exit(1);
			}
  	}
  	else {
	 		fprintf(stderr,"RA file format version %d not supported",in[5]);
			exit(1);
		}
	}
	else if (!strncmp(in,".RMF",4)) {
		fprintf(stderr,"Real media files (RMF) not currently supported");
		exit(1);
	}
	else {
		fprintf(stderr,"unrecognized file format");
		exit(1);
	}
	printf("\nDecoding done");
	return 0;
}
